#!/usr/bin/env python
# -*- coding:Utf-8 -*-

# Authors: Julien CAYSSOL <julien@aqwz.com>
# Contributors: Fabrice MOURRON <fab@revhosts.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#
# Version 0.1
#
## Require :
## - pyDNS <http://pydns.sourceforge.net/>

# Librairies

from threading import BoundedSemaphore, Thread
import sys,thread, os
from time import sleep, time, ctime

try :
        import DNS
except ImportError :
        print "Please install the pyDNS package for python <http://pydns.sourceforge.net/>"
        sys.exit()  

# name/dns server Object
class Process:
	serveur = None
	Liste  = []


lock = []
avancement = []
result = []

hand = BoundedSemaphore(1)

# Read a file
def openfile(nomDuFichier):
        file = open(nomDuFichier,'r')
        data = file.readlines()
        file.close()
        return data

# Proces of brute force
def setprocess(lwords, lservers):
	
	list_process = []
	serveurs = openfile(lservers)
	
	nbs = len(serveurs)
	nbd = len(openfile(lwords))
	if nbs == 0:
		print "No dns server in file"
		sys.exit()

	compteur = 0
	group = 0
	p = Process()
	p.serveur = serveurs[group]
 	list = []	
	print nbd/nbs
	for mot in openfile(lwords):
		list.append(mot.rstrip())
		if compteur >= nbd/nbs+1:
			# On met la list dans l'objet p	
			p.Liste=list
			# On ajout l'objet  notre list process
			list_process.append(p)

			#on init nos var
			compteur = 0
			group = group +1

			list = []
			# On init un nouvel objet
			p = Process()
			p.serveur = serveurs[group]

		compteur = compteur + 1 

	p.Liste=list
	list_process.append(p)
	return list_process


# Query on the dns server
def querry(nom, serveur):
	r = DNS.Request(name=nom, server=serveur, qtype='A')
	try:
		a = r.req()
	except DNS.Error:
		return 0
	# Not null on a donc une rponse
	if a.header['ancount'] != 0:
		hand.acquire()		
		result.append(nom)
		hand.release()
		return 1

def credits():
	print "~"*41
	print "|     Brute Force DNS (Multithread)     |"
	print "|             Team Revhosts             |"
	print "~"*25+" 08/2006 "+"~"*7

def usage():
	print " ./script domain servers_list dictionary"
	print "        ex : ./script domaine.com server.lst hosts-txt"

def recap(domaine, lservers, lwords):
	print "[*] Domain : ", domaine
	print "[*] Server List : ", lservers
	print "[*] Dictionary : ", lwords


def proc0(liste , domaine, serveur, id):
      for i in liste:
	        avancement[id]=avancement[id]+1
		querry(i+'.'+domaine,serveur)
      lock.append('serveur')


def main(domaine, lservers,lwords):
	recap(domaine, lservers,lwords)
	# Init the list of DNS / name server
	list_proc = setprocess(lwords,lservers)
	nbs = len(list_proc)
	print "Start at :", ctime(time())
	id = 0
	for s in list_proc:
		avancement.append(0)
		thread.start_new_thread(proc0,(s.Liste,domaine, s.serveur, id))
		id = id +1
        try:	
		while(len(lock)!=nbs):	
			os.system('clear') 
			print "---------------------------| Information |---------------------------------"
			id = 0
			tot = 0
			for s in list_proc:
				print "-[*] -- ", s.serveur.rstrip()
				print "     +- thread in progress : ", avancement[id], " hosts of ", len(s.Liste)
				tot = tot+avancement[id]
				id = id +1
			print "---------------------------------------------------------------------------"
			print "- Total in progress :  ",tot
			print "- Find hosts : "
			print result
			sleep(1)
	except(KeyboardInterrupt): 
		print "---------- End of scan -----------"

	print "End at :", ctime(time())
	print result


if __name__ == "__main__":
        credits()
	if ( len(sys.argv) <= 3):
		usage()
	else:
		domaine = sys.argv[1]
		lservers = sys.argv[2] 
		lwords = sys.argv[3]
	        main(domaine, lservers,lwords)



